org.cpsolver.coursett

## Class TimetableXMLLoader

- java.lang.Object
- - org.cpsolver.ifs.util.ProblemLoader<Lecture,Placement,TimetableModel>
  - - org.cpsolver.coursett.TimetableLoader
    - - org.cpsolver.coursett.TimetableXMLLoader

- All Implemented Interfaces:
    Runnable

      public class TimetableXMLLoader
      extends TimetableLoader

  This class loads the input model from XML file.
  Parameters:

  Related Solver Parameters
  Parameter | Type | Comment
  --- | --- | ---
  General.Input | `String` | Input XML file
  General.DeptBalancing | `Boolean` | Use `DepartmentSpreadConstraint`
  General.InteractiveMode | `Boolean` | Interactive mode (see `Lecture.purgeInvalidValues(boolean)`)
  General.ForcedPerturbances | `Integer` | For testing of MPP: number of input perturbations, i.e., classes with prohibited intial assignment
  General.UseDistanceConstraints | `Boolean` | Consider distances between buildings

  Version:
    CourseTT 1.3 (University Course Timetabling)
    Copyright (C) 2006 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `TimetableXMLLoader.DatePattern`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TimetableXMLLoader(TimetableModel model, Assignment<Lecture,Placement> assignment)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `doLoad(Solution<Lecture,Placement> currentSolution, Element root)`
    `static Date` | `getDate(int year, int dayOfYear)`
    `Solver<Lecture,Placement>` | `getSolver()`
    `void` | `load()` Load the model.
    `void` | `load(Solution<Lecture,Placement> currentSolution)`
    `void` | `load(Solution<Lecture,Placement> currentSolution, Document document)`
    `void` | `setInputFile(File inputFile)`
    `void` | `setSolver(Solver<Lecture,Placement> solver)`

    - ### Methods inherited from class org.cpsolver.ifs.util.ProblemLoader

      `getAssignment, getModel, getTerminationCondition, run, setCallback, setTerminationCondition`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TimetableXMLLoader

          public TimetableXMLLoader(TimetableModel model,
                                    Assignment<Lecture,Placement> assignment)

  - ### Method Detail

    - #### setSolver

          public void setSolver(Solver<Lecture,Placement> solver)

    - #### getSolver

          public Solver<Lecture,Placement> getSolver()

    - #### setInputFile

          public void setInputFile(File inputFile)

    - #### load

          public void load()
                    throws Exception

      Description copied from class: `ProblemLoader`
      Load the model.
      Specified by:
        `load` in class `ProblemLoader<Lecture,Placement,TimetableModel>`
      Throws:
        `Exception` - thrown when the load fails

    - #### load

          public void load(Solution<Lecture,Placement> currentSolution)
                    throws Exception

      Throws:
        `Exception`

    - #### load

          public void load(Solution<Lecture,Placement> currentSolution,
                           Document document)

    - #### doLoad

          protected void doLoad(Solution<Lecture,Placement> currentSolution,
                                Element root)

    - #### getDate

          public static Date getDate(int year,
                                     int dayOfYear)